#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

$WEBDIR = "/usr/local/www";
$CGIDIR = "$WEBDIR/cgi-bin";

#
# This file creates the live switch display
#
####### BEGIN MAIN ########
        push(@INC, "$CGIDIR");
        require 'mon-lib.pl';

        &ReadInput(*INPUT);
        &ParseData(*GLOBAL, $INPUT);
	$hostname = &IpswitchName();

        # Print out header
#        &PrintButtonBar("HEADER", "Diagnostics on $hostname");
        &SetUpMenuBar;
        &IpTraceHelp;
        &IpPingHelp;
        &IpxPingHelp;
        &IpxSapTableHelp;
	# Print out form
	&diagForm();

        # Print out trailer
	print "<hr size=4>";
#        &PrintButtonBar("TRAILER");
        &PrintToe; 

####### END MAIN ########

sub PrintToe {
    &SetUpHelp;
    &PrintHeadToe("TRAILER",
		  "", 
		  "",
		  "",
		  "/cgi-bin/diag.pl?IH=$nhelp",
                  "");
}

sub SetUpMenuBar {
    &SetUpHelp;
    &PrintHeadToe("HEADER",
		  "Diagnostics on : $hostname", 
		  "",
		  "",
		  "/cgi-bin/diag.pl?IH=$nhelp",
		  "");
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagRouteTable.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub IpTraceHelp {
    &SetUpHelp;
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagIpTrace.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub IpPingHelp {
    &SetUpHelp;
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagIpPing.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub IpxPingHelp {
    &SetUpHelp;
    if ($ihelp eq "on") {
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        print "<font -= 4><br>"; 
        open(FD, "/usr/local/config/help/monitor.diagIpxPing.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub IpxSapTableHelp {
    &SetUpHelp;
    if ($ihelp eq "on") {
        print "<font -= 4><br>"; 
        print "<img src=\"/images/config/helpbar.gif\"><br>";
        open(FD, "/usr/local/config/help/monitor.diagSapTable.html");
        while (<FD>) {
            print;    
        }             
        close(FD);    
        print "<font += 4>";
        print "<img src=\"/images/config/bar.gif\"><br>";
    }
}

sub diagForm {

    &SetUpHelp;
    print "<!-- ***** Main Content -->\n";
    print "<center>\n";
#    print "<h1>Run from '$hostname'</h1>\n";
    print "<table border=0 align=center valign=top cellpadding=0>\n";
    print "<th colspan=0></th>\n";
    print "<tr></tr>\n\n";

    print "<!-- ****** Row 1 -->\n<tr>\n";
    print "<td ><A HREF=\"/cgi-bin/netstat.pl?IH=$ihelp\"><font size=+1><b>Routing Table</b></font></A></td></tr><tr><td></td></tr>\n";

    print "<!-- ****** Row 2 -->\n<tr>\n";
    print "<td ><br><FORM method=\"POST\" ACTION=\"/cgi-bin/NPH-traceroute.pl?IH=off\"><font size=+1><b>IP Trace Route </b></font></td>\n";
    print "<td colspan=2>Destination Address<br><INPUT TYPE=text SIZE=20 NAME=IPADDR></td>\n";
    print "<td ><br><br><INPUT type=submit NAME=\"TRACEROUTE\" VALUE=\"  OK  \"></FORM></td></tr>\n";

    print "<!-- ****** Row 3 -->\n<tr>\n";
    print "<td ><br><FORM method=\"POST\" ACTION=\"/cgi-bin/NPH-ping.pl?IH=off\"><font size=+1><b>IP Ping </b></font></td>\n";
    print "<td colspan=2>Destination  Address<br><INPUT TYPE=text SIZE=20 NAME=IPADDR></td>\n";
    print "<td ><br>Repeat<br><INPUT TYPE=text SIZE=5 NAME=REP VALUE=5><br> times</td>\n";
    print "<td ><br><br><INPUT type=submit NAME=\"PING\" VALUE=\"  OK  \"></FORM></td></tr>\n";

    print "<!-- ****** Row 4 -->\n<tr>\n";
    print "<td ><br><FORM method=\"POST\" ACTION=\"/cgi-bin/NPH-ipxping.pl?IH=off\"><font size=+1><b>IPX Ping </b></font></td>\n";
    print "<td >Network<br><INPUT TYPE=text SIZE=8 NAME=IPXNET></td>\n";
    print "<td >Node<br><INPUT TYPE=text SIZE=12 NAME=IPXNODE VALUE=FFFFFFFFFFFF></td>\n";
    print "<td ><br>Repeat<br><INPUT TYPE=text SIZE=5 NAME=IPXREP VALUE=5><br> times</td>\n";
    print "<td ><br><br><INPUT type=submit NAME=\"IPXPING\" VALUE=\"  OK  \"></FORM></td></tr>\n";

    print "<!-- ****** Row 5 -->\n<tr>\n";
    print "<td colspan=3><A HREF=\"/cgi-bin/ipxsap.pl?IH=$ihelp\"><font size=+1><b>IPX SAP Table</b></font></A></td></tr><tr><td></td></tr>\n";

#    print "<!-- ****** Row 6 -->\n<tr>\n";
#    print "<td ><A HREF=\"/cgi-bin/ifconfig.pl\"><font size=+1>Interface Configuration</font></A></td></tr>\n";

    print "</table>\n";
    print "</center>\n";
    print "</BODY>\n</HTML>\n";

}

