#!/usr/bin/perl

sub get {
  local($thing) = @_;
  open (FD, "/usr/local/config/bin/dbget $thing |");
  $result=<FD>;
  close(FD);
  chop($result);
  return($result);
}

sub machine_get {
  local($thing) = @_;
  $prefix="machine:";
  $prefix.=$machine;
  $f=$prefix;
  $f.=":";
  $f.=$thing;
  return(&get($f));
}

sub entry {
  local($thing,$name) = @_;
  if ($thing){
    print "<tr><td><b>$name</b></td> <td>$thing</td></tr>";
  }
}

$machine=&get("machine");
$time=&get("time");

if ($machine) {
  $uptime=&machine_get("uptime");
  $swvers=&machine_get("ipsoversion");
  $serial_num=&machine_get("serialnumber");
  $phymemory=&machine_get("phymemory");
  $type="IP Switch Processor";
}

print STDOUT <<"EOF";
Content-type: text/html\n\n
<html>
<head><title>clearVISN IP Switch Manager: $machine</title></head>
<Body bgcolor=\"f0f0f0\">
<center>
<a href="http://www.networks.digital.com"><img border=0 src="/images/voyager.gif" alt="Digital"></a>
EOF


if ($machine=~ /Error/ || $serial_num=~ /Error/ || $phymemory=~ /Error/ ||
    $swver=~ /Error/ || $uptime=~ /Error/) {
   print "\n\n\n<h1>This system is not operational.</h1>\n";
   return;
}

print "<h1>$machine</h1>\n";
print "<table>\n";
&entry($serial_num,"Serial Number");
&entry($swvers,"Software Version");
&entry($time,"Current Time");
($days, $t) = split(",",$uptime);
($hours,$mins) = split(":",$uptime);
if (!$t) {
    if (!$mins) {
	$realtime = $uptime;
    }else{
        $realtime = "$hours hours, $mins minutes";
    }
} else {
    ($hours,$mins) = split(":",$t);  
    if ($mins) {
	$realtime = "$days, $hours hours, $mins minutes";
    } else {
	$realtime = $uptime;
    }
};
&entry($realtime,"Uptime");
&entry($type,"Type");
&entry($phymemory,"Physical Memory");
print "</table>\n";


print STDOUT <<"EOF";
<table align=center><tr>
<td align=center valign=bottom> <a href="/cgi-bin/html_page?TEMPLATE=main"><img border=0 src="/images/config.gif" alt="Configuration"></a> 
<td align=center valign=bottom>  <a href="/cgi-bin/switch"><img border=0 src="/images/monitor.gif" alt="Monitor"></a> 
<td align=center valign=bottom>  <a href="/voy.guide/Main_tasks.html"><img border=0 src="/images/doc.gif" alt="Documentation"></a> 
</tr>
</table></center></body></html>
EOF
