#!/usr/bin/perl
######################################################################
# Copyright 1995, 1996 Ipsilon Networks, Inc. All rights reserved.
#
# YOU MAY ONLY USE THE MATERIALS FOUND IN THIS FILE PURSUANT TO THE
# TERMS OF THE EVALUATION LICENSE AGREEMENT FOUND IN "/LICENSE".  ALL
# OTHER USES ARE EXPRESSLY PROHIBITED.
######################################################################

sub ParseSysctl {
	local($IPSSYSCTL)	= "/usr/sbin/sysctl"; 
	local($CTLMIBOBJ)	= @_; 
	local($_);

	if(!open(READSYSCTL_1, "$IPSSYSCTL $CTLMIBOBJ | "))
		{ &PrintMsgHdr("Can't open $IPSSYSCTL: $!"); return 1;	}
	while (<READSYSCTL_1>) {
		chop;
		if (/^$/ || !/(^ips\.\S*)\s*=\s*(.*)/)
			{ next;	}
		if (/^ips\.if\[(\d*)\]\.index\s*=\s*(.*)/)
			{ local($tmp) = "tool.iflist_to_if[$2]"; $ips_data{$tmp} = $1; }
		$ips_data{$1} = $2;
	}
	close(READSYSCTL_1); return;
}

sub ParseIflistSysctl {
	local($IPSSYSCTL)	= "/usr/sbin/sysctl"; 
	local($CTLMIBOBJ)	= "net.route.all.iflist"; 
	local($ips_nic_flag,$skip_entry)= 0;
	local($ifindex, $ifobj, $val);
	local($_);

	if(!open(READSYSCTL, "$IPSSYSCTL $CTLMIBOBJ | "))
		{ &PrintMsgHdr("Can't open $IPSSYSCTL: $!"); return 1;	}

	while (<READSYSCTL>) {
		chop;
		if (/^$/)
			{ next;	}
		if (!/net\.route\.all\.iflist\[(\d*)\]\.(\S*)\s*=\s*(.*)/)
			{ next; }
		$ifindex = $1; $ifobj = $2; $val = $3;
		if ($ifobj eq "name") {
			$skip_entry = 0;
			if ($IPSDEVTYPE eq "controller") {
				if ($val =~ /atm/) {
					if ($val =~ /atm-(s\d*p\d*c\d*)$/)
						{ $ips_nic_flag = 1; $chassis{1} = 1; }
					else {
						$ips_nic_flag = 0;
						if ($val =~ /atm-(s\d*p\d*c\d*)(s\d*p\d*c\d*)$/) {
							$chassis{2} = 1;
							if ($ips_far eq "NONE")
								{ $ips_far = $1; }
						}
						else
							{ $skip_entry = 1; next; }
					}
					$iflocation = &IfLocation($val);
				} 
				else
					{ $skip_entry = 1; next; }
			} elsif ($IPSDEVTYPE eq "gateway") {
				if ($val =~ /(eth)-(s\d*p\d*c\d*)/ || $val =~ /(atm)-(s\d*p\d*c\d*)/ || $val =~ /(fddi)-(s\d*p\d*c\d*)/) {
					if ($1 eq "atm") {
						$ips_nic_flag = 1; $ips_far = $2;
						$iflocation = &IfLocation($val, $2);
					}
					else
						{ $ips_nic_flag = 0; $iflocation = &IfLocation($val, $2+1); }
				}
				else
					{ $skip_entry = 1; next; }
			}
		}
		elsif ($skip_entry) 
			{ next; }
		$temp= sprintf("if%s.%s", $iflocation, $ifobj);
#print "Parse: $temp = $val\n";
		if ($ips_nic_flag) {
			$nic_data{$temp} = $val;
			if ($ifobj eq "name") {
				$temp= sprintf("if%d.ifindex", $iflocation);
				$nic_data{$temp} = $ifindex;
			}
		}
		else {
			$ips_data{$temp} = $val;
			if ($ifobj eq "name") {
				$temp= sprintf("if%d.ifindex", $iflocation);
				$ips_data{$temp} = $ifindex;
			}
		}
	}
	close(READSYSCTL); return;
}

1;
